/*
    By   Qianfeng Zhang ( frzhang@redhat.com )  November 2009 
*/


#include <qpid/client/FailoverManager.h>
#include <qpid/client/Session.h>
#include <qpid/client/AsyncSession.h>
#include <qpid/Exception.h>

#include <iostream>
#include <sstream>

#include "FailoverWorker.h"
#include "demo_common.h"

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


using namespace qpid;
using namespace qpid::client;
using namespace qpid::framing;

using namespace demo;
using namespace std;

namespace demo {

FailoverWorker::FailoverWorker(int nodeInd, string &hostIP, int nodes, int port) : 
           nodeIndex(nodeInd), brokerNodes(nodes)  
{
   in_addr_t net, host;
   struct in_addr startip, theip;   // ip address structure
   int adjust; 
   
   /* nodeInd let us know the first node we try our connection to  */
   adjust = nodeInd % nodes; 
   inet_aton(hostIP.c_str(), &startip);
   host = inet_lnaof(startip);
   net = inet_netof(startip);
   
   for (int i=0; i< nodes; i++) {
       ostringstream os; 

       theip = inet_makeaddr(net, host+ (i+adjust) % nodes);
       os << "amqp:tcp:" << inet_ntoa(theip) << ":"  << port;

       cout << "debugging: "  << os.str() << endl;

       Url myurl(os.str());

       theUrls.push_back(myurl);

       if ( i == 0 )   {
           settings.host = inet_ntoa(theip);
           settings.port = port;
           settings.heartbeat = HB_INTERVAL;
           lastUrl = myurl; 
       }
   }

}

void FailoverWorker::editUrlList(std::vector<Url>& urls)
{
     //  initialize "urls" to our configured "theUrls" 
     if  (  urls.size() == 0 ) 
            urls = theUrls; 

     if  (  urls.size() > 1 ) {
         if ( urls.back()  != lastUrl ) {
              std::vector<Url>::iterator pos ;
              pos = find( urls.begin(), urls.end(), lastUrl); 
              if (pos != urls.end()) {
                  urls.erase(pos);
                  urls.push_back(lastUrl);
                  lastUrl = urls.front(); 
              } 
         }
     }   
}

}


