/*
    By   Qianfeng Zhang ( frzhang@redhat.com )  November 2009 
*/


#ifndef _failover_worker_h
#define _failover_worker_h

#include <qpid/client/FailoverManager.h>
#include <qpid/client/Session.h>
#include <qpid/client/AsyncSession.h>
#include <qpid/Exception.h>

#include <iostream>
#include <sstream>

using namespace qpid;
using namespace qpid::client;
using namespace qpid::framing;

using namespace std;

namespace demo {

class FailoverWorker :  public FailoverManager::Command,  
                        public FailoverManager::ReconnectionStrategy 
{
   public: 
      FailoverWorker(int nodeInd, string& hostIP, int nodes, int port); 
      ~FailoverWorker() {}; 
      virtual void execute(AsyncSession& session, bool isRetry) {} ;
      void editUrlList(std::vector<Url>& urls);

   protected:
       ConnectionSettings settings;
       int  nodeIndex;  // this is used for load balancing, let different Workers connect to different nodes
                        // the stationID or stockGID can be used for nodeIndex

   private:   
       int  brokerNodes;
       Url  lastUrl;  
       vector<Url> theUrls;     // this vector is not used so far 
};

}  //namespace "demo"
#endif

