#!/bin/bash

## create several direct exchanges and their attached queues
set -e 

MAX_STOCK_GROUP=2
MAX_STATION=2

/usr/bin/qpid-config  add exchange direct "exchg_A" --sequence
/usr/bin/qpid-config  add exchange direct "exchg_B" --sequence 
/usr/bin/qpid-config  add exchange direct "exchg_C" --sequence 

for  i in `seq ${MAX_STOCK_GROUP}` ;  do
   /usr/bin/qpid-config add queue "A_$i" --max-queue-count 20000 --limit-policy reject;
   /usr/bin/qpid-config bind "exchg_A" "A_$i" "Key_$i"
done  

for i  in `seq ${MAX_STATION}` ;  do 
   /usr/bin/qpid-config add queue "B_$i" --max-queue-count 20000 --limit-policy reject;
   /usr/bin/qpid-config bind "exchg_B" "B_$i" "Key_$i"
done 


for i  in `seq ${MAX_STATION}` ;  do 
   /usr/bin/qpid-config add queue "C_$i" --max-queue-count 20000 --limit-policy reject;
   /usr/bin/qpid-config bind "exchg_C" "C_$i" "Key_$i"
done 

